<!--
{
  "documentType" : "article",
  "framework" : "AppStoreConnectAPI",
  "identifier" : "/documentation/AppStoreConnectAPI/builds",
  "metadataVersion" : "0.1.0",
  "role" : "collectionGroup",
  "title" : "Builds"
}
-->

# Builds

Manage builds for testers and submit builds for review.

## Discussion

A `builds` resource represents a single build of an app. You must upload builds using Xcode, Transporter, or the [Build uploads](/documentation/AppStoreConnectAPI/build-uploads) resource. Once App Store Connect processes the build, it appears as a build resource.

Once the build is in the system, you can use the API to perform actions like:

- Submitting builds for review.
- Individually assigning builds to testers.
- Adding the build to a beta group for testing.

## Topics

### Getting Build Information

[`GET /v1/builds`](/documentation/AppStoreConnectAPI/GET-v1-builds)

Find and list builds for all apps in App Store Connect.

[`GET /v1/builds/{id}`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_)

Get information about a specific build.

[`GET /v1/builds/{id}/app`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-app)

Get the app information for a specific build.

[`GET /v1/builds/{id}/relationships/app`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-app)

Get the app ID for a specific build.

[`GET /v1/builds/{id}/appStoreVersion`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-appStoreVersion)

Get the App Store version of a specific build.

[`GET /v1/builds/{id}/relationships/appStoreVersion`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-appStoreVersion)

[`GET /v1/builds/{id}/preReleaseVersion`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-preReleaseVersion)

Get the prerelease version for a specific build.

[`GET /v1/builds/{id}/relationships/preReleaseVersion`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-preReleaseVersion)

[`GET /v1/builds/{id}/metrics/betaBuildUsages`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-metrics-betaBuildUsages)

Get usage metrics for a specific build.

### Modifying Builds

[`PATCH /v1/builds/{id}`](/documentation/AppStoreConnectAPI/PATCH-v1-builds-_id_)

Expire a build or change its encryption exemption setting.

[`PATCH /v1/builds/{id}/relationships/appEncryptionDeclaration`](/documentation/AppStoreConnectAPI/PATCH-v1-builds-_id_-relationships-appEncryptionDeclaration)

Assign an app encryption declaration to a build.

### Adding and Removing Build Access

[`POST /v1/builds/{id}/relationships/betaGroups`](/documentation/AppStoreConnectAPI/POST-v1-builds-_id_-relationships-betaGroups)

Add or create a beta group to a build to enable testing.

[`DELETE /v1/builds/{id}/relationships/betaGroups`](/documentation/AppStoreConnectAPI/DELETE-v1-builds-_id_-relationships-betaGroups)

Remove access to a specific build for all beta testers in one or more beta groups.

[`POST /v1/builds/{id}/relationships/individualTesters`](/documentation/AppStoreConnectAPI/POST-v1-builds-_id_-relationships-individualTesters)

Enable a beta tester who is not a part of a beta group to test a build.

[`DELETE /v1/builds/{id}/relationships/individualTesters`](/documentation/AppStoreConnectAPI/DELETE-v1-builds-_id_-relationships-individualTesters)

Remove access to test a specific build from one or more individually assigned testers.

### Listing Individually Assigned Beta Testers

[`GET /v1/builds/{id}/individualTesters`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-individualTesters)

Get a list of beta testers individually assigned to a build.

[`GET /v1/builds/{id}/relationships/individualTesters`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-individualTesters)

Get a list of resource IDs of individual testers associated with a build.

### Checking Beta Review Submission Status

[`GET /v1/builds/{id}/betaAppReviewSubmission`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-betaAppReviewSubmission)

Get the beta app review submission status for a specific build.

[`GET /v1/builds/{id}/relationships/betaAppReviewSubmission`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-betaAppReviewSubmission)

### Getting Information Associated with Builds

[`GET /v1/builds/{id}/buildBetaDetail`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-buildBetaDetail)

Get the beta test details for a specific build.

[`GET /v1/builds/{id}/relationships/buildBetaDetail`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-buildBetaDetail)

[`GET /v1/builds/{id}/appEncryptionDeclaration`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-appEncryptionDeclaration)

Read an app encryption declaration associated with a specific build.

[`GET /v1/builds/{id}/relationships/appEncryptionDeclaration`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-appEncryptionDeclaration)

Get the beta app encryption declaration resource ID associated with a build.

[`GET /v1/builds/{id}/betaBuildLocalizations`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-betaBuildLocalizations)

Get a list of localized beta test information for a specific build.

[`GET /v1/builds/{id}/relationships/betaBuildLocalizations`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-betaBuildLocalizations)

[`GET /v1/builds/{id}/diagnosticSignatures`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-diagnosticSignatures)

List the aggregate backtrace signatures captured for a specific build.

[`GET /v1/builds/{id}/icons`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-icons)

List all the icons for various platforms delivered with a build.

[`GET /v1/builds/{id}/relationships/icons`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-icons)

[`GET /v1/builds/{id}/relationships/diagnosticSignatures`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-diagnosticSignatures)

[`GET /v1/builds/{id}/relationships/appStoreVersion`](/documentation/AppStoreConnectAPI/GET-v1-builds-_id_-relationships-appStoreVersion)

### Objects and data types

[`Build`](/documentation/AppStoreConnectAPI/Build)

A processed binary uploaded to App Store Connect, ready for TestFlight distribution or App Store submission.

[`BuildResponse`](/documentation/AppStoreConnectAPI/BuildResponse)

The response body for endpoints that read or modify a single build.

[`BuildWithoutIncludesResponse`](/documentation/AppStoreConnectAPI/BuildWithoutIncludesResponse)

A response containing a single build, without related resources.

[`BuildsResponse`](/documentation/AppStoreConnectAPI/BuildsResponse)

The response body for endpoints that list builds.

[`BuildsWithoutIncludesResponse`](/documentation/AppStoreConnectAPI/BuildsWithoutIncludesResponse)

A response containing a list of builds, without related resources.

[`BuildUpdateRequest`](/documentation/AppStoreConnectAPI/BuildUpdateRequest)

The request body you use to update a Build.

[`BuildAppEncryptionDeclarationLinkageRequest`](/documentation/AppStoreConnectAPI/BuildAppEncryptionDeclarationLinkageRequest)

The request body you use to attach an app encryption declaration to a build.

[`BuildAppEncryptionDeclarationLinkageResponse`](/documentation/AppStoreConnectAPI/BuildAppEncryptionDeclarationLinkageResponse)

A response body that contains the ID of a single related resource.

[`BuildIndividualTestersLinkagesRequest`](/documentation/AppStoreConnectAPI/BuildIndividualTestersLinkagesRequest)

A request body you use to add or remove a build from multiple beta groups.

[`BuildIndividualTestersLinkagesResponse`](/documentation/AppStoreConnectAPI/BuildIndividualTestersLinkagesResponse)

A response body that contains a list of related resource IDs.

[`BuildBetaGroupsLinkagesRequest`](/documentation/AppStoreConnectAPI/BuildBetaGroupsLinkagesRequest)

A request body you use to add or remove beta groups from a build.

[`ImageAsset`](/documentation/AppStoreConnectAPI/ImageAsset)

An image asset, including its height, width, and template URL.

[`BetaBuildUsagesV1MetricResponse`](/documentation/AppStoreConnectAPI/BetaBuildUsagesV1MetricResponse)

A response that contains one or more beta build metric resources.

[`BuildAppLinkageResponse`](/documentation/AppStoreConnectAPI/BuildAppLinkageResponse)

[`BuildAppStoreVersionLinkageResponse`](/documentation/AppStoreConnectAPI/BuildAppStoreVersionLinkageResponse)

[`BuildBetaAppReviewSubmissionLinkageResponse`](/documentation/AppStoreConnectAPI/BuildBetaAppReviewSubmissionLinkageResponse)

[`BuildBetaBuildLocalizationsLinkagesResponse`](/documentation/AppStoreConnectAPI/BuildBetaBuildLocalizationsLinkagesResponse)

[`BuildBetaDetailBuildLinkageResponse`](/documentation/AppStoreConnectAPI/BuildBetaDetailBuildLinkageResponse)

[`BuildDiagnosticSignaturesLinkagesResponse`](/documentation/AppStoreConnectAPI/BuildDiagnosticSignaturesLinkagesResponse)

[`BuildIconsLinkagesResponse`](/documentation/AppStoreConnectAPI/BuildIconsLinkagesResponse)

[`BuildPerfPowerMetricsLinkagesResponse`](/documentation/AppStoreConnectAPI/BuildPerfPowerMetricsLinkagesResponse)

[`BuildPreReleaseVersionLinkageResponse`](/documentation/AppStoreConnectAPI/BuildPreReleaseVersionLinkageResponse)

[`BuildAudienceType`](/documentation/AppStoreConnectAPI/BuildAudienceType)

A string that represents the App Store Connect audience for a build.

[`DiagnosticInsightDirection`](/documentation/AppStoreConnectAPI/DiagnosticInsightDirection)

A string that describes the diagnostic insight direction.

[`DiagnosticInsightType`](/documentation/AppStoreConnectAPI/DiagnosticInsightType)

A string that desribes the diagnostic insight type.



---

Copyright &copy; 2026 Apple Inc. All rights reserved. | [Terms of Use](https://www.apple.com/legal/internet-services/terms/site.html) | [Privacy Policy](https://www.apple.com/privacy/privacy-policy)